#include "Rational.h"
#include <cassert>
#include <string>
#include <sstream>

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational::Rational()
{
	num = 0;
	den = 1;
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational::Rational(const Rational& original) : num(original.num),
den(original.den)  // initializer list
{
	// Nothing else to do
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational::Rational(long int nm, long int dn)
{
	assert(dn);
	if(dn<0) {
		nm *= -1;
		dn *= -1;
	}
	num = nm;
	den = dn;
	reduce();
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational::~Rational()
{
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational& Rational::operator=(const Rational& rhs)
{
	num = rhs.num;
	den = rhs.den;
	return *this;
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
void Rational::insert(std::ostream& os) const
{
	os << num << '/' << den;
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational Rational::operator+(const Rational& rhs) const
{
	Rational temp;
	temp.den = den*rhs.den;
	temp.num = num*rhs.den + rhs.num*den;
	temp.reduce();
	return temp;
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
Rational Rational::operator-(const Rational& rhs) const
{
	Rational temp(num*rhs.den-rhs.num*den, den*rhs.den);
	return temp;
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
const Rational& Rational::operator+=(const Rational& rhs)
{
	num = num*rhs.den + rhs.num*den;
	den = den*rhs.den;
	reduce();
	return *this;
}

// Zbynek Srubar and Jonathan Dunder, 3-24-2004
bool Rational::operator<(const Rational& rhs) const
{
	return (num*static_cast<long int>(rhs.den) < rhs.num * static_cast<long int>(den));
}

// Zbynek Srubar and Jonathan Dunder, 3-24-2004
bool Rational::operator<=(const Rational& rhs) const
{
	return (num*rhs.den <= rhs.num * den);
}

// Rolando Leal and ?, 3-25-2004
bool Rational::operator==(const Rational& rhs) const
{
	return ((num == rhs.num) && (den == rhs.den));
}

// Rolando Leal and ?, 3-25-2004
bool Rational::operator!=(const Rational& rhs) const
{
	return !(*this == rhs);
}

//-2/7
// Randy Wittorp and Dominick O'Dierno, 3-25-2004
/*bool Rational::extract( std::istream &is) 
{
	std::string	rtnl;
	int  slashpos;
	std::stringstream	numstream;
	std::stringstream	denstream;
	is >> rtnl;
	int slashcount = 0;
	for ( int i = 0; i<rtnl.size(); ++i)
	{
		if(rtnl[i] >= '0' && rtnl[i] <= '9' || rtnl[i] == '/' || rtnl[i] == '-' )
		{
			if ( rtnl[i] == '/')
			{
				++slashcount;
			}
		}
		else
		{
			return false;
		}
	}
	if (slashcount > 1)
	{
		return false;
	}
	if (slashcount < 1)
	{
		numstream << rtnl;
		numstream >> num;
		den = 1;
		return true;
	}
	slashpos = rtnl.find( "/",0 );
	if ( slashpos != std::string::npos )
	{
		numstream << rtnl.substr( 0 , slashpos );
		denstream << rtnl.substr( slashpos + 1, rtnl.size() - slashpos - 1 );
		numstream >> num;
		denstream >> den;
		return true;
	}
	else
	{
		return false;
	}
}*/

bool Rational::extract(std::istream &is) 
{
	bool worked = false;
	long int nm;
	long int dn;
	char slash;
	if(is >> nm >> slash >> dn && ('/'==slash)) {
		Rational temp(nm, dn);
		*this = temp;
		worked = true;
	}
	return worked;
}

// Karol Schober and David Ibanez, 3-25-2004
Rational Rational::operator/(const Rational& rhs) const{

	Rational temp(num*rhs.den,den*rhs.num);

	return temp;
}

// Karol Schober and David Ibanez, 3-25-2004
Rational Rational::operator*(const Rational& rhs) const{

	Rational temp(num*rhs.num, den*rhs.den);

	return temp;
}

// Karol Schober and David Ibanez, 3-25-2004
void Rational::reduce(){

	for (int i=2; i<=den; i++){
		
		while (num%i==0 && den%i==0 ) {
			num/=i;
			den/=i;
		}
	}
}

// Taryn Colwell and ?, 3-26-2004
bool Rational::operator>(const Rational& rhs) const
{
	return (num*rhs.den > rhs.num * den);
}

// Taryn Colwell and ?, 3-26-2004
bool Rational::operator>=(const Rational& rhs) const
{
	return (num*rhs.den >= rhs.num * den);
}

// Randy Wittorp and Dominick O'Dierno, 3-25-2004
std::istream& operator>>(std::istream &is, Rational& rtnl)
{
	rtnl.extract( is );
	return is;
}

// Alex Stuart and Derek Bressler, 2-25-2004
double Rational::export()const
{
	return static_cast<double>(num)/den;
}

// Dr. Taylor's Spring 2004 CS-183-1 class, 3-22-04
std::ostream& operator<<(std::ostream& os, const Rational& rtnl)
{
	rtnl.insert(os);
	return os;
}







